diff --git a/src/backend/access/table/toast_helper.c b/src/backend/access/table/toast_helper.c
index 0cc5a30f9b..c04f9c14d2 100644
--- a/src/backend/access/table/toast_helper.c
+++ b/src/backend/access/table/toast_helper.c
@@ -326,10 +326,11 @@ toast_delete_external(Relation rel, Datum *values, bool *isnull,
 	{
 		if (TupleDescAttr(tupleDesc, i)->attlen == -1)
 		{
-			Datum		value = values[i];
-
 			if (isnull[i])
 				continue;
+
+			Datum		value = values[i];
+
 			else if (VARATT_IS_EXTERNAL_ONDISK(PointerGetDatum(value)))
 				toast_delete_datum(rel, value, is_speculative);
 		}
